var conf_scheduler_admin = { selectedIDs: [] };


jQuery( document ).ready( function( $ ) {
  var isSession = $('body.taxonomy-conf_sessions').length;

  if(isSession) {
    $('#start').datetimepicker({
      format: 'yyyy-mm-dd H:ii p',
      todayBtn:  1,
  		autoclose: 1,
  		todayHighlight: 1,
  		forceParse: 0,
      showMeridian: 1,
      keyboardNavigation: false,
      pickerPosition: 'bottom-left'
    });

  } else { //is workshop

    // Call select2 on sessions select
    $('#session').select2();

    // setup AJAX for listing registered participants
    $('#list_registered').click(function(e) {
      e.stopPropagation(); // stop workshop from collapsing
      var $this = $(this);
      var $list = $('#registered .list');
      if($list.length) {
        $list.toggle();
        if ($list.is(':visible') ) {
          $this.text('Hide');
        } else {
          $this.text('List');
        }
      } else {
        $('#registered').append('<div class="list"><div class="spinner is-active"></div></div>');
        var workshopID = $('#post_ID').val();
        $.ajax( {
            url : ajaxurl,
            type: 'POST',
            data: {
                action  : 'conf_scheduler_list_participants',
                'workshop_id': workshopID,
            },
            context: this,
            success: function( data ) {
              $(this).text('Hide');
              $('#registered .list').html(data);
            },
            error: function( data ) {
              $('#registered .spinner').remove();
            }
        } );
      }
    });


    // Uploading files
  	var file_frame;
  	var wp_media_post_id = wp.media.model.settings.post.id; // Store the old id

    conf_scheduler_admin.renderAttachments = function() {
      $( '#file_attachments' ).html('');
      conf_scheduler_admin.selectedIDs.forEach(function(ID) {
        var a = wp.media.attachment(ID).attributes;
        var preview = a.sizes ? a.sizes.thumbnail.url : a.icon;
        $( '#file_attachments' ).append('<div class="workshop_file" data-workshopid="'+a.id+'"><div class="preview"><img src="'+preview+'"></div><span class="title">'+a.title+'</span>File Name: <a href="'+a.url+'">'+a.filename+'</a><br/>File Size: '+a.filesizeHumanReadable+'<a class="remove_file"></a></div>');
      });
      if (conf_scheduler_admin.selectedIDs.length == 0) {
        $( '#file_attachments' ).html('No attachments selected.');
      }
      $('.workshop_file .remove_file').click(function(event) {
        event.preventDefault();
        conf_scheduler_admin.selectedIDs = conf_scheduler_admin.selectedIDs.filter(e => e !== $(this).parent().data('workshopid'));
        $( '#file_attachments_id' ).val(conf_scheduler_admin.selectedIDs.join());
        $(this).parent().remove();
      });

      $( '#file_attachments_id' ).val( conf_scheduler_admin.selectedIDs.join() );

    }

    //preload selected attachments
    if($( '#file_attachments_id' ).val())
      conf_scheduler_admin.selectedIDs = $( '#file_attachments_id' ).val().split(',').map(Number);
    wp.media.query({ post__in: conf_scheduler_admin.selectedIDs })
      .more()
      .then(function() {
        conf_scheduler_admin.renderAttachments();
      });

  	jQuery('#upload_file_button').on('click', function( event ){
  		event.preventDefault();

  		// If the media frame already exists, reopen it.
  		if ( file_frame ) {
  			// Set the post ID to what we want
  			//file_frame.uploader.uploader.param( 'post_id', selected_media_id );
  			// Open frame
  			file_frame.open();
  			return;
  		} else {
  			// Set the wp.media post id so the uploader grabs the ID we want when initialised
  			//wp.media.model.settings.post.id = selected_media_id;

    		// Create the media frame.
    		file_frame = wp.media.frames.file_frame = wp.media({
    			title: 'Select workshop attachments',
    			button: {
    				text: 'Select',
    			},
    			multiple: true	// Set to true to allow multiple files to be selected
    		});

    		// When an image is selected, run a callback.
    		file_frame.on( 'select', function() {
    			// We set multiple to false so only get one image from the uploader
    			var attachments = file_frame.state().get('selection');
          conf_scheduler_admin.selectedIDs = attachments.models.map(function(a) { return a.attributes.id; });

          conf_scheduler_admin.renderAttachments();
    		});

        file_frame.on('open',function() {
          var selection = file_frame.state().get('selection');
          conf_scheduler_admin.selectedIDs.forEach(function(id) {
            // all attachments are prefetched at load or on select
            attachment = wp.media.attachment(id);
            selection.add( attachment ? [ attachment ] : [] );
          });
        });

  			file_frame.open();
      }
  	});
  }
});
